> For the complete documentation index, see [llms.txt](https://docs.openreview.net/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.openreview.net/how-to-guides/paper-matching-and-assignment/how-to-add-remove-bids-programmatically.md).

# How to add/remove bids programmatically

Bids are represented by Edges where the `head` is the Note `id` of the submission and the `tail` is the Profile `id` of the user that is doing the bid. Bids have an optional property `label` and in this case it is being used to represent the type of bid, for example: "Very High", "High", "Neutral", "Low" and "Very Low".

Members of the official committee usually use the "Bidding Console" to create and edit these bids. However, bids can also be updated programmatically.

#### Editing bids:

Every time you update a bid you need to set the signatures. The signatures must be a group id where you have signatory permissions. The bid Invitation specifies that the signature must be either a profile id or the venue id. In the example below, the signature is "ICML.cc/2023/Conference":

```python
edge = client.get_edge(bid_id)
edge.label = 'Very High'
edge.signatures = ["ICML.cc/2023/Conference"]
edge.nonreaders = None
client.post_edge(edge)
```

#### Removing bids:

To remove bids, you need to a the `ddate` value using a timestamp in milliseconds. This change will perform a soft delete which means that this bid can be restored.

<pre class="language-python"><code class="lang-python">edge = client.get_edge(bid_id)
<strong>edge.ddate = 1664467200000
</strong>edge.signatures = ["ICML.cc/2023/Conference"]
edge.nonreaders = None
client.post_edge(edge)
</code></pre>

#### Restoring bids:

To restore bids, you need to get the deleted bid and remove the `ddate` value. This is achieved by passing an object `{ delete: true }`. Be aware that the invitation must allow a this operation by passing an object with "`deletable: true`", otherwise, this action cannot be performed.

```python
edge = client.get_edge(bid_id)
edge.ddate = { 'delete': True }
edge.signatures = ["ICML.cc/2023/Conference"]
edge.nonreaders = None
client.post_edge(edge)
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.openreview.net/how-to-guides/paper-matching-and-assignment/how-to-add-remove-bids-programmatically.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
